import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Space extends World
{
    private int score;
    private int time;
    public Space()
    {    
        super(780, 360, 1); 

        prepare();prepare();
        setPaintOrder(Earth.class);
        score = 0;
        showScore();
        time = 2000;
        showTime();
    }

    private void countTime()
    {
        time--;
        showTime();
        
        if(time == 0)
        {
            showEndMessage();
            Greenfoot.stop();
        }
    }
    
    private void showTime()
    {
        showText("Time:" + time, 700, 20);
    }
    
    private void showEndMessage()
    {
        showText("Time is up - you win!", 390, 150);
        showText("Your final score:" + "points" + score, 390, 170);
    }    
    
    public void addScore(int points)
    {
        score = score + points;
        showScore();
        if (score < 0)
        {
            Greenfoot.playSound("game-over.wav");
            Greenfoot.stop();
        }
    }

    private void showScore()

    {
        showText("Score: " + score, 80, 25);
    } 
    
    public void act()
    {
        if (Greenfoot.getRandomNumber(100) < 3)
        {
            addObject(new Orb(), 779, Greenfoot.getRandomNumber(360));
        }

        if (Greenfoot.getRandomNumber(100) < 1)
        {
            addObject(new Spacejunk(), 779, 6);
            addObject(new Spacejunk(), 740, 354);
        }

        if (Greenfoot.getRandomNumber(200) < 1)
        {
            addObject(new Blackhole(), 779, Greenfoot.getRandomNumber(360));
        }

        if (Greenfoot.getRandomNumber(100) < 4
        )
        {
            addObject(new Asteroid(), 779, Greenfoot.getRandomNumber(360));
        }
        countTime();
    }

    private void prepare()
    {

        Sun sun = new Sun();
        addObject(sun,6,198);
        Earth earth = new Earth();
        addObject(earth,776,187);
        Rocket rocket = new Rocket();
        addObject(rocket,179,192);
        Spacejunk spacejunk = new Spacejunk();
        addObject(spacejunk,140,19);
        Spacejunk spacejunk2 = new Spacejunk();
        addObject(spacejunk2,373,20);
        Spacejunk spacejunk3 = new Spacejunk();
        addObject(spacejunk3,583,26);
        Spacejunk spacejunk4 = new Spacejunk();
        addObject(spacejunk4,729,27);
        Spacejunk spacejunk5 = new Spacejunk();
        addObject(spacejunk5,128,359);
        Spacejunk spacejunk6 = new Spacejunk();
        addObject(spacejunk6,398,355);
        Spacejunk spacejunk7 = new Spacejunk();
        addObject(spacejunk7,654,355);
        Spacejunk spacejunk8 = new Spacejunk();
        addObject(spacejunk8,661,347);
    }
}
